Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 636476 - media-sound/abcde: Can't locate WebService/MusicBrainz/Release.pm in @INC
Summary: media-sound/abcde: Can't locate WebService/MusicBrainz/Release.pm in @INC
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal with 1 vote (vote)
Assignee: Gentoo Sound Team
URL:
Whiteboard:
Keywords:
Depends on: 687230 688800
Blocks:
  Show dependency tree
 
Reported: 2017-11-04 00:57 UTC by zlg (RETIRED)
Modified: 2020-07-30 23:55 UTC (History)
4 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description zlg (RETIRED) gentoo-dev 2017-11-04 00:57:50 UTC
When using media-sound/abcde-2.8.1 to query for CDDB data (with MusicBrainz), abcde emits this error:


$ abcde -kp -o ogg:flac -V                                                               
Executing customizable pre-read function... done.                                          
Getting CD track info... dasd: 1 6  150 86369 0                                            
9873                                                                                       
22503                                                                                      
42024                                                                                      
59157                                                                                      
70868                                                                                      
Can't locate WebService/MusicBrainz/Release.pm in @INC (you may need to install the WebServ
ice::MusicBrainz::Release module) (@INC contains: /etc/perl /usr/local/lib64/perl5/5.26.1/x
86_64-linux /usr/local/lib64/perl5/5.26.1 /usr/lib64/perl5/vendor_perl/5.26.1/x86_64-linux
/usr/lib64/perl5/vendor_perl/5.26.1 /usr/lib64/perl5/5.26.1/x86_64-linux /usr/lib64/perl5/5
.26.1) at /usr/bin/abcde-musicbrainz-tool line 19.                          
BEGIN failed--compilation aborted at /usr/bin/abcde-musicbrainz-tool line 19.       
(Ctrl-C'd as it rips the CD without gathering information)


I looked into the problem and found that dev-perl/WebService-MusicBrainz-1.0.2 introduces a single entry point for its (new) API v2. media-sound/abcde is using the prior API (including latest from git upstream), explaining the breakage.

Downgrading to dev-perl/WebService-MusicBrainz-0.940.0 fixes the problem and 
abcde will correctly fetch data from MusicBrainz.

Proposed Solution: 

RDEPEND="musicbrainz? ( <dev-perl/WebService-MusicBrainz-1.0.2 )"

Both abcde-2.5.4-r1 and abcde-2.8.1 will need this dependency updated.

emerge --info abcde WebService-MusicBrainz:

Portage 2.3.13 (python 3.4.6-final-0, default/linux/amd64/13.0/developer, gcc-6.4.0, glibc-2.25-r8, 4.13.7-gentoo x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-4.13.7-gentoo-x86_64-AMD_Phenom-tm-_II_X6_1090T_Processor-with-gentoo-2.4.1
KiB Mem:    16430384 total,  11044460 free
KiB Swap:    8388604 total,   8388604 free
Head commit of repository gentoo: c3bbadcf660c19398167b2156fffcd279122fabd

sh bash 4.4_p12
ld GNU ld (Gentoo 2.29.1 p3) 2.29.1
app-shells/bash:          4.4_p12::gentoo
dev-java/java-config:     2.2.0-r3::gentoo
dev-lang/perl:            5.26.1::gentoo
dev-lang/python:          2.7.13::gentoo, 3.4.6::gentoo, 3.5.4::gentoo, 3.6.3::gentoo
dev-util/cmake:           3.9.4::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.4.1-r2::gentoo
sys-apps/openrc:          0.34.4::gentoo
sys-apps/sandbox:         2.12::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.11.6-r2::gentoo, 1.15.1-r1::gentoo
sys-devel/binutils:       2.29.1-r1::gentoo
sys-devel/gcc:            4.9.4::gentoo, 6.4.0::gentoo
sys-devel/gcc-config:     1.9.0::gentoo
sys-devel/libtool:        2.4.6-r4::gentoo
sys-devel/make:           4.2.1-r1::gentoo
sys-kernel/linux-headers: 4.13::gentoo (virtual/os-headers)
sys-libs/glibc:           2.25-r8::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: git
    sync-uri: rsync://rsync.us.gentoo.org/gentoo-portage
    priority: -1000

zlg-overlay
    location: /home/zlg/projects/overlay
    masters: gentoo

0x4d4c
    location: /var/lib/layman/0x4d4c
    sync-type: laymansync
    sync-uri: https://github.com/0x4d4c/gentoo-overlay.git
    masters: gentoo
    priority: 50

gamerlay
    location: /var/lib/layman/gamerlay
    sync-type: laymansync
    sync-uri: git://anongit.gentoo.org/proj/gamerlay.git
    masters: gentoo
    priority: 50

games-overlay
    location: /var/lib/layman/games-overlay
    sync-type: laymansync
    sync-uri: git://github.com/hasufell/games-overlay.git
    masters: gentoo
    priority: 50

octopus
    location: /var/lib/layman/octopus
    sync-type: laymansync
    sync-uri: https://github.com/Bfgeshka/octopus.git
    masters: gentoo
    priority: 50

steam-overlay
    location: /var/lib/layman/steam-overlay
    sync-type: laymansync
    sync-uri: git://github.com/anyc/steam-overlay.git
    masters: gentoo
    priority: 50

Installed sets: @base, @dev, @games, @main, @palemoon
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-march=native -O2 -pipe"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--ask-enter-invalid --binpkg-respect-use=y --oneshot"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs collision-protect compress-build-logs config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync multilib-strict news parallel-fetch preserve-libs protect-owned sandbox sfperms sign splitdebug strict test-fail-continue unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://mirrors.evowise.com/gentoo/ http://gentoo.gossamerhost.com http://mirror.leaseweb.com/gentoo/ http://gentoo.mirrors.tds.net/gentoo http://cosmos.illinois.edu/pub/gentoo/"
LANG="en_US.UTF-8"
LDFLAGS="-Wl,--hash-style=gnu -Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j6"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac acl acpi alsa amd64 bash-completion branding bzip2 cairo cdda cdr cli consolekit cracklib crypt cups cxx dbus dri dts dvd dvdr emboss encode exif fam firefox flac fortran gdbm gif glamor gtk iconv ipv6 jpeg lcms ldap libnotify mad mng modules mp3 mp4 mpeg multilib ncurses nls nptl ogg opengl openmp pam pango pcre pdf png policykit ppds pulseaudio qt3support qt4 readline sdl seccomp session snmp spell ssl startup-notification svg tcpd tiff truetype udev unicode usb vim-syntax vorbis wxwidgets x264 xattr xcb xft xml xv xvid zlib" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="3dnow 3dnowext mmx mmxext popcnt sse sse2 sse3 sse4a" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="keyboard mouse evdev joystick wacom" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6" POSTGRES_TARGETS="postgres9_5" PYTHON_SINGLE_TARGET="python3_4" PYTHON_TARGETS="python2_7 python3_4 python3_5 python3_6" RUBY_TARGETS="ruby22 ruby23 ruby24" USERLAND="GNU" VIDEO_CARDS="nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

=================================================================
                        Package Settings
=================================================================

media-sound/abcde-2.8.1::gentoo was built with the following:
USE="aac cdr flac id3tag lame musicbrainz vorbis -cdparanoia -mac -musepack -normalize -opus -replaygain -speex -wavpack" ABI_X86="(64)"


dev-perl/WebService-MusicBrainz-0.940.0::gentoo was built with the following:
USE="" ABI_X86="(64)"
Comment 1 Preston Crow 2018-02-04 03:37:58 UTC
This is a simple version incompatibility.

I put the following in /etc/portage/package.mask/package.mask and it solved the problem:
# Changes break abcde
>=dev-perl/WebService-MusicBrainz-1.0.2

I expect it would make sense to update the ebuild for abcde to make the dependency on an older version of dev-perl/WebService-MusicBrainz, and then as long as you don't have to have a newer version for something else, everything is fine.

Hopefully this will be fixed upstream someday, but it's now been a year since the last release of abcde, so who knows?
Comment 2 Mikko Mensonen 2018-05-06 07:43:56 UTC
There is an upstream bug about this and it has now been fixed:
https://abcde.einval.com/bugzilla/show_bug.cgi?id=60

A new version (2.9.1) was released a few months ago.
Comment 3 Robin Bankhead 2019-03-05 21:38:01 UTC
FWIW, current version 2.9.3 (released last month) built and ran OK for me on ~amd64 just by revbumping the 2.8.1 ebuild.
Comment 4 Derek Dolney 2019-06-02 22:05:46 UTC
As of 1 Aug 2018 metabrainz deprecated the v1 API and therefore afaict <dev-perl/WebService-MusicBrainz-1 is no longer functional (at least will not work for abcde). Use of v1 returns the link below which is the deprecation announcement:

https://blog.metabrainz.org/2018/02/01/web-service-ver-1-0-ws-1-will-be-removed-in-6-months/
Comment 5 Preston Crow 2020-07-30 23:55:56 UTC
This has been fixed upstream.  You can close the bug.